#ifndef DATETIMECFG_H_
#define DATETIMECFG_H_

#include "gType.h" 
#include "GraphLow.h"
#include "GraphBase.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "my_string.h"
#include "Device.h"
#include "EpDevice.h"
#include "StaticText.h"
#include "TEdit.h"

class TDateTimeCfg{
	public:
		static constexpr unsigned short hList[12] = {80,80,60,32,	32,32,32,32,	32,32,32,32};
		static constexpr unsigned short wList[12] = {800,800,800,800,	800,800,800,800,	800,800,800,800};
		static constexpr TLv Lv = {
			.Caption.Left = 0,
			.Caption.Top = 36,
			.Caption.Width = 800,
			.Caption.Heigh = 32,
			.Caption.Right = 800 -0 -1,
			.Caption.Bottom = 36 + 32,
			
			.Grid.Left = {0,0,0,0,	0,0,0,0,	0,0,0,0},
			.Grid.Right = {wList[0]-1,wList[1]-1,wList[2]-1,wList[3]-1,	wList[4]-1,wList[5]-1,wList[6]-1,wList[7]-1,	wList[8]-1,wList[9]-1,wList[10]-1,wList[11]-1},
			.Grid.Top[0] = (36 + 32 +8),
			.Grid.Top[1] = (36 + 32 +8) + (2 + hList[0]),
			.Grid.Top[2] = (36 + 32 +8) + (2 + hList[0]) + (2 + hList[1]),
			.Grid.Top[3] = (36 + 32 +8) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]),
				
			.Grid.Bottom[0] = (36 + 32 +8) + hList[0],
			.Grid.Bottom[1] = (36 + 32 +8) + (2 + hList[0]) + hList[1],
			.Grid.Bottom[2] = (36 + 32 +8) + (2 + hList[0]) + (2 + hList[1]) + hList[2],
			.Grid.Bottom[3] = (36 + 32 +8) + (2 + hList[0]) + (2 + hList[1]) + (2 + hList[2]) + hList[3],
			
			.Grid.UsingCount = 3,
			
			.Panel.Active = 0,
			.Panel.ItemType = piMemo,
			.PanelSmall.Active = 0,
		};
	public:
		unsigned char IsShow;
		unsigned char OpaState;
		unsigned char SlaveDateTimeHasBeenSet;
		unsigned char Dump0;
		struct{
			unsigned char Group;
			unsigned char Inx0;
			unsigned char Inx1;
			unsigned char Inx2;
		}Tag;
	
		TRect Bound;
		TRect BoundCaption;
		TRect Content;
	
		unsigned char vtValue[8];
		unsigned char DecVal[8];
		unsigned int IsEditing;
		
		char vtText[6][4];
		char Text[16];
		class TEdit vEdit;
	public:
		TDateTimeCfg(){};
		void Init();
		void RenderBackGround(void);
		void DrawSelf();
		void DrawBoxTimeOutLine();
		void DrawBoxTime();
		void DrawBoxTimeString();
		void DrawDateEntry();
		void DrawTimeEntry();
		void DrawSaveButton();
		void Show();
		void FullRedraw(int Prm);
		void DrawTextFirst();
			
		void ShowSta();
		void ShowSta(unsigned char aSta);
			
		void LoadDateTime();
			
		void DrawNwSetDateTime(int Selected);
			
		void SetEditStart(void);
		void RestoreFromEdit(void);
			
		TGuiMsgReturn KeyIn(unsigned char aKey);
			
		void CombDt();
			
		int ExtRequst(unsigned char Prm){IsShow =0; return 0;}
};



#endif

